.586
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\user32.inc 
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib

.data

align 16
  num     dq 1152921504606846978    ; 2^60 + 2      64 / 64  with reminder
  den     dq    1125899906842627    ; 2^50 + 3

 ;   num     dq 1152921504606846978    ; 2^60 + 2      64 /  0  Error division by zero
 ;   den     dq                   0    ; 0

 ;   num     dq 1152921504606846978    ; 2^60 + 2      64 /  1  Division by one
 ;   den     dq                   1    ; 1

 ;   num     dq 1152921504606846976    ; 2^60          64 / 64  no remainder
 ;   den     dq    1125899906842624    ; 2^50

 ;   num     dq 1152921504606846977    ; 2^60 + 1      64 / 32  with remainder
 ;   den     dq                   8    ; 8

 ;   num     dq                 101    ; 101           32 / 32  with remainder
 ;   den     dq                   5    ; 5

  quo     dq                   0
  rem     dq                   0

  dont    dd 0
  
  szBefore     db  256 dup (0)
  szBeforeFmt  db "%8x %08x Numerator  ",13,10
               db "%8x %08x Denominator",0

;  szBeforeFmt  db "%lx %lx %lx %lx",0    ; quick debugging

  szAfter      db  256 dup (0)
  szAfterFmt   db "%8x %08x Quotient ",13,10
               db "%8x %08x Remainder",0

  szCaption    db "(Unsigned) QWord division",0
  szDivZeroErr db "Would have been division by zero",0

.code
start:
  mov edx, dword ptr num+4
  mov ecx, dword ptr num+0
  mov ebx, dword ptr den+4
  mov eax, dword ptr den+0
  invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, edx, ecx, ebx, eax  ; num+4, num, den+4, den
  invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK


;             handle division by 0
  .if (dword ptr den+0 == 0) && (dword ptr den+4 == 0)
    invoke MessageBox, NULL, addr szDivZeroErr, addr szCaption, MB_OK
    mov dont, 1

;             handle division by 1
  .elseif (dword ptr den+0 == 1) && (dword ptr den+4 == 0)
     mov edx, dword ptr num+4
     mov eax, dword ptr num+0
     mov dword ptr quo+4, edx
     mov dword ptr quo+0, eax
     mov dword ptr rem+4, 0
     mov dword ptr rem+0, 0

;             handle division of 32 bit values
  .elseif (dword ptr num+0 != 0) && (dword ptr num+4 == 0) && \
          (dword ptr den+0 != 0) && (dword ptr den+4 == 0)
     mov edx, dword ptr num+4
     mov eax, dword ptr num+0
     mov ecx, dword ptr den+0
     div ecx
     mov dword ptr quo+4, 0
     mov dword ptr quo+0, eax
     mov dword ptr rem+4, 0
     mov dword ptr rem+0, edx

;             handle division of 64 bit by 32 bit
  .elseif (dword ptr num+0 >= 0) && (dword ptr num+4 != 0) && \
          (dword ptr den+0 != 0) && (dword ptr den+4 == 0)
    mov eax, dword ptr den+0
    .if eax <= dword ptr num+4
       mov edx, 0
       mov eax, dword ptr num+4
       mov ecx, dword ptr den+0
       div ecx
       mov dword ptr quo+4, eax
       mov dword ptr rem+4, 0
;         mov edx, edx               ; remainder from div in edx already edx:eax
       mov eax, dword ptr num+0
;         mov ecx, dword ptr den+0   ; ecx already loaded
       div ecx
       mov dword ptr quo+0, eax
       mov dword ptr rem+0, edx
    .else
       mov edx, dword ptr num+4
       mov eax, dword ptr num+0
       mov ecx, dword ptr den+0
       div ecx
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, eax
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, edx
    .endif

;             handle division of 64 bit by 64 bit
  .elseif (dword ptr num+0 >= 0) && (dword ptr num+4 != 0) && \
          (dword ptr den+0 >= 0) && (dword ptr den+4 != 0)
    mov edx, dword ptr den+4
    mov eax, dword ptr den+0
    .if edx > dword ptr num+4     ; den > num
       mov edx, dword ptr num+4
       mov eax, dword ptr num+0
       mov dword ptr quo+4, edx
       mov dword ptr quo+0, eax
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, 0
    .elseif (eax == dword ptr num+0) && (edx == dword ptr num+4)  ; den == num
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, 1
       mov dword ptr rem+4, 0
       mov dword ptr rem+0, 0
    .else
       mov edx, 0
       mov eax, dword ptr num+4
       mov ecx, dword ptr den+4
       .if (dword ptr den+0 > 0)
         inc ecx
       .endif
       div ecx
       mov dword ptr quo+4, 0
       mov dword ptr quo+0, eax
       mov ecx, eax
       mov edx, 0
       mov eax, dword ptr den+0
       mul ecx
       mov dword ptr rem+4, edx
       mov dword ptr rem+0, eax
       mov ebx, edx
       mov edx, 0
       mov eax, dword ptr den+4
       mul ecx
       add eax, ebx
       mov dword ptr rem+4, eax
       mov edx, dword ptr num+4
       mov eax, dword ptr num+0
       sub eax, dword ptr rem+0
       sbb edx, dword ptr rem+4
       mov dword ptr rem+4, edx
       mov dword ptr rem+0, eax
    .endif   
  .endif

 ;   invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, num+4, num, den+4, den
 ;   invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK
 ;   invoke wsprintf, ADDR szAfter,  ADDR szAfterFmt,  quo+4, quo, rem+4, rem
 ;   invoke MessageBox, NULL, addr szAfter, addr szCaption, MB_OK

 ;   mov edx, dword ptr num+4
 ;   mov ecx, dword ptr num+0
 ;   mov ebx, dword ptr den+4
 ;   mov eax, dword ptr den+0
 ;   invoke wsprintf, ADDR szBefore, ADDR szBeforeFmt, edx, ecx, ebx, eax
 ;   invoke MessageBox, NULL, addr szBefore, addr szCaption, MB_OK

  .if dont == 0
    mov edx, dword ptr quo+4
    mov ecx, dword ptr quo+0
    mov ebx, dword ptr rem+4
    mov eax, dword ptr rem+0
    invoke wsprintf, ADDR szAfter,  ADDR szAfterFmt,  edx, ecx, ebx, eax
    invoke MessageBox, NULL, addr szAfter, addr szCaption, MB_OK
  .endif

  invoke ExitProcess, NULL
end start